{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 1991-1999 Peter Mandrella                                   }
{                                                                 }
{ Aenderungen des XP2 Teames unterliegen urheberrechtlich         }
{ dem XP2 Team, weitere Informationen unter: http://www.xp2.de    }
{                                                                 }
{ Basierend auf der Sourcebuild vom 09.04.2000 des OpenXP Teams.  }
{ Aenderungen des Sources, die vom OpenXP Teams getaetigt wurden, }
{ unterliegen den Rechten, die bis zum 09.04.2000 fuer das OpenXP }
{ Team gueltig waren.                                             }
{                                                                 }
{ CrossPoint ist eine eingetragene Marke von Peter Mandrella.     }
{                                                                 }
{ Die Nutzungsbedingungen fuer diesen Quelltext finden Sie in der }
{ Datei SLIZENZ.TXT oder auf www.crosspoint.de/srclicense.html.   }


{ --- Bearbeitungs-Routinen fr RFC/PPP-Boxen ------------------- }

{$I XPDEFINE.INC}
{$IFDEF BP }
  {$O+,F+,R-}
{$ENDIF }

unit xp9ppp;

interface

uses xpglobal,crt,dos,typeform,fileio,inout,keys,winxp,win2,maske,
     datadef,database,maus2,mouse,resource,xp0,xp1,xp1o,xp1o2,xp1input,xp2c;

function cvtlang(s: string; engtoger: boolean):string;
procedure EditPOP3(var brk:boolean);
procedure EditSMTP(var brk:boolean);
procedure EditNNTP(var brk:boolean);
procedure EditZugang(var brk:boolean);
procedure EditClients(var brk:boolean);

implementation  {-------------------------------------------------}

uses xp2,xp3,xp3o,xp9,xp9bp,xp10,xpnt,xpterm;
  {
  maddint: ...typ,displ,von,bis
  Typ 2 = ShortInt, 3 = Byte, 4 = Integer, 5 = Word, 6 = LongInt
  }

  function cvtlang(s: string; engtoger: boolean):string;
  var
    s1,s2: string[60];
    p    : byte;
  begin
    s:=trim(s); s2:='';
    repeat
      p:=blankpos(s);
      if p=0 then p:=length(s)+1;
      s1:=left(s,p-1);
      s:=trim(mid(s,p));
      if engtoger then
        if lstr(s1)='enabled' then s2:=s2+'aktiviert ' else
        if lstr(s1)='disabled' then s2:=s2+'deaktiviert ' else
        s2:=s2+s1+' '
      else
        if lstr(s1)='aktiviert' then s2:=s2+'enabled ' else
        if lstr(s1)='deaktiviert' then s2:=s2+'disabled ' else
        s2:=s2+s1+' ';
    until s='';
    cvtlang:=rtrim(s2);
  end;

  procedure EditPOP3(var brk:boolean);
  var x,y: byte;
  begin
    dialog(45,17,getres2(936,1),x,y);  { 'POP3-Einstellungen' }
    with BoxPar^ do begin
      Pop3UseEnvelope:=cvtlang(Pop3UseEnvelope,deutsch);
      Pop3Keep:=cvtlang(Pop3Keep,deutsch);
      Pop3Auth:=cvtlang(Pop3Auth,deutsch);
      maddstring(3,2,getres2(936,6)+'    ',Pop3Server,26,200,'');      { 'Server     ' }
      mhnr(9000);
      maddstring(3,3,getres2(936,7)+'    ',Pop3User,26,200,'');        { 'User       ' }
      maddstring(3,4,getres2(936,8)+'    ',Pop3Pass,26,100,'');        { 'Passwort   ' }
      maddstring(3,5,getres2(936,9)+'    ',Pop3Envelope,26,200,'');    { 'Envelope   ' }
      maddstring(3,6,getres2(936,10),Pop3UseEnvelope,26,110,'');       { 'UseEnvelope' }
      mappsel(false,getres2(936,54));                                  { 'aktiviertdeaktiviert' }
      maddstring(3,7,getres2(936,11),Pop3Keep,26,110,'');              { 'Keep       ' }
      mappsel(false,getres2(936,54));                                  { 'aktiviertdeaktiviert' }
      maddstring(3,8,getres2(936,12)+'    ',Pop3Spool,26,255,'');      { 'Spool      ' }
      maddstring(3,10,getres2(936,53),Pop3Auth,13,110,'');             { 'sichere Authentifizierung verwenden' }
      mappsel(false,getres2(936,54));                                  { 'aktiviertdeaktiviert' }
      maddstring(3,12,getres2(936,13),Pop3Port,10,50,'0123456789 ');   { 'Port       ' }
      maddint(31,12,getres2(936,14),Pop3TimeOut,4,3,0,999);            { 'TimeOut    ' }
      maddint(3,14,getres2(936,51),Pop3MaxLen,6,7,0,9999999);          { 'MaxLen   ' }
      maddbool(3,16,getres2(936,43),IMAP);                             { 'POP3/IMAP  ' }
      freeres;
      readmask(brk);
      Pop3UseEnvelope:=cvtlang(Pop3UseEnvelope,false);
      Pop3Keep:=cvtlang(Pop3Keep,false);
      Pop3Auth:=cvtlang(Pop3Auth,false);
      enddialog;
    end;
  end;

  procedure EditSMTP(var brk:boolean);
  var x,y: byte;
  begin
    dialog(49,16,getres2(936,2),x,y);  { 'SMTP-Einstellungen' }
    with BoxPar^ do begin
      maddstring(3,2,getres2(936,6),SmtpServer,34,200,'');           { 'Server         ' }
      mhnr(9020);
      maddstring(3,3,getres2(936,7),SmtpUser,34,200,'');             { 'User           ' }
      maddstring(3,4,getres2(936,8),SmtpPass,34,100,'');             { 'Passwort       ' }
      maddstring(3,5,getres2(936,9),SmtpEnvelope,34,200,'');         { 'Envelope       ' }
      maddstring(3,6,getres2(936,12),SmtpSpool,34,255,'');           { 'Spool          ' }
      SmtpAuth:=cvtlang(SmtpAuth,deutsch);
      maddstring(3,8,getres2(936,53),SmtpAuth,17,110,'');            { 'sichere Authentifizierung verwenden' }
      mappsel(false,getres2(936,55)); { 'aktiviertdeaktiviertautoLoginPlainDigest-MD5Cram-MD5' }
      maddstring(3,10,getres2(936,13),SmtpPort,10,50,'0123456789 '); { 'Port           ' }
      maddint(35,10,getres2(936,14),SmtpTimeOut,4,3,0,999);          { 'TimeOut        ' }
      maddint(12,12,getres2(936,16),SmtpAfterPopTimeOut,4,3,0,999);  { 'AfterPopTimeOut' }
      maddint(12,13,getres2(936,17),SmtpAfterPopDelay,4,3,0,999);    { 'AfterPopDelay  ' }
      maddbool(3,15,getres2(936,15),SmtpAfterPop);                   { 'AfterPop       ' }
      freeres;
      readmask(brk);
      SmtpAuth:=cvtlang(SmtpAuth,false);
      enddialog;
    end;
  end;

  procedure EditNNTP(var brk:boolean);
  var x,y: byte;
  begin
    dialog(49,19,getres2(936,3),x,y);  { 'NNTP-Einstellungen' }
    with BoxPar^ do begin
      maddstring(3,2,getres2(936,6),NntpServer,34,200,'');    { 'Server   ' }
      mhnr(9040);
      maddstring(3,3,getres2(936,7),NntpUser,34,200,'');      { 'User     ' }
      maddstring(3,4,getres2(936,8),NntpPass,34,100,'');      { 'Passwort ' }
      maddstring(3,5,getres2(936,12),NntpSpool,34,255,'');    { 'Spool    ' }
      maddint(3,7,getres2(936,13),NntpPort,6,5,0,99999);      { 'Port     ' }
      maddint(35,7,getres2(936,14),NntpTimeOut,4,3,0,999);    { 'TimeOut        ' }
      maddbool(3,9,getres2(936,18),NntpList);                 { 'Newsliste' }
      maddbool(3,10,getres2(936,19),NntpRescan);              { 'Rescan   ' }
      maddbool(3,11,getres2(936,49),NntpPosting);             { 'Posting   ' }
      maddbool(3,12,'  '+getres2(936,52),ReplaceOwn);         { 'ReplaceOwn ' }
      maddint(3,14,getres2(936,20),NntpQueue,4,6,1,20);       { 'Queue    ' }
      maddint(3,15,getres2(936,45),NntpArtclAnz,4,6,0,32000); { 'Anzahl   ' }
      maddint(3,16,getres2(936,21),NntpMaxLen,6,6,0,999999);  { 'MaxLen   ' }
      maddint(3,17,getres2(936,22),NntpNewMax,6,6,0,999999);  { 'NewMax   ' }
      maddint(3,18,getres2(936,23),NntpDupeSize,6,6,0,999999);{ 'DupeSize ' }
      freeres;
      readmask(brk);
      enddialog;
    end;
  end;

  procedure EditZugang(var brk:boolean);
  var x,y: byte;
  begin
    dialog(49,17,getres2(936,5),x,y);  { 'Zugangs-Einstellungen' }
    with BoxPar^ do begin
      maddstring(3,2,getres2(936,24),DialInAccount,29,40,'');           { 'Account       ' }
      mhnr(9060);
      maddstring(3,3,getres2(936,7)+'     ',DialInUser,29,40,'');       { 'User          ' }
      maddstring(3,4,getres2(936,8)+'     ',DialInPass,29,25,'');       { 'Passwort      ' }
      maddstring(3,5,getres2(936,25),DialInNumber,29,25,'0123456789wW');{ 'Rufnummer     ' }
      maddbool(3,7,getres2(936,26),PerformPass);                        { 'Perform Password entry' }
      maddbool(3,8,getres2(936,27),AfterDialinState);                   { 'Disconnect after Dial-In State' }
      maddbool(3,9,getres2(936,28),AskForDisconnect);                   { 'Ask for Disconnect' }
      maddint(3,11,getres2(936,29),RedialOnBusy,4,3,0,999);             { 'Redial on busy' }
      maddint(3,12,getres2(936,30),RedialTimeout,4,3,0,999);            { 'Redial TimeOut' }
      maddint(3,13,getres2(936,50),HangupTimeout,4,3,0,999);            { 'Verbindung trennen nach' }
      maddtext(3,15,getres2(936,47),col.coldiahigh);                    { 'Pakete mitsenden' }
      maddstring(3,16,getres2(936,48),PPP_BoxPakete,28,200,'');          { 'Name der Boxen '}
      msetvfunc(TestPPPservers);  { prfen, ob PPP-Box und ob vorhanden ! }
      freeres;
      readmask(brk);
      enddialog;
    end;
  end;

  procedure EditClients(var brk:boolean);
  var
    x,y        : byte;
    StoreSpool : string[79];
  begin
    dialog(47,9,getres2(936,4),x,y);  { 'Clients-Einstellungen' }
    with BoxPar^ do begin
      StoreSpool:=PPP_UUZ_Spool;
      maddstring(3,2,getres2(936,31),PPP_Dialer,30,79,'');    { 'DialIn  ' }
      mhnr(9080);
      mappsel(false,'WDIAL.EXE /DIAL $CONFIG');
      msetvfunc(progtest);
      maddstring(3,3,getres2(936,44),PPP_HangUp,30,79,'');    { 'DialOut ' }
      mappsel(false,'WDIAL.EXE /HANGUP $CONFIG');
      msetvfunc(progtest);
      maddstring(3,4,getres2(936,32),PPP_Mail,30,160,'');     { 'Mail    ' }
      mappsel(false,'XP3P.EXE -CONFIG:$CONFIG -SMTPE-MAIL.EXE $CONFIG');
      msetvfunc(progtest);
      maddstring(3,5,getres2(936,33),PPP_News,30,160,'');     { 'News    ' }
      mappsel(false,'E-NEWS.EXE $CONFIG');
      msetvfunc(progtest);
      maddstring(3,6,getres2(936,34),PPP_UUZ_In,30,255,'');   { 'UUZ-In  ' }
      mappsel(false,'UUZ.EXE -uz $SCREENLINES $SPOOL $PUFFER');
      msetvfunc(uuz_in_test);
      maddstring(3,7,getres2(936,35),PPP_UUZ_Out,30,255,'');  { 'UUZ-Out ' }
      mappsel(false,'UUZ.EXE -zu -SMTP -ppp -1522 -qp -MIME -absnsstyle $PUFFER $SPOOL');
      msetvfunc(uuz_out_test);
      maddstring(3,8,getres2(936,46),PPP_UUZ_Spool,30,79,''); { 'UUZ-Spool ' }
      msetVfunc(formpath);
      freeres;
      readmask(brk);
      if not brk and (ustr(StoreSpool)<>ustr(PPP_UUZ_Spool)) then begin
        Pop3Spool:=PPP_UUZ_Spool;
        SmtpSpool:=PPP_UUZ_Spool;
        NntpSpool:=PPP_UUZ_Spool;
      end;
      enddialog;
    end;
  end;

end.

